# -*- coding: utf-8 -*-
#create by zhaotao
from PySide2 import QtWidgets, QtCore, QtGui
from PySide2.QtCore import Qt
import os
import json
import pymel.core as pm
import QuickSelectCreateWidget
reload(QuickSelectCreateWidget)
import QuickSelectRuleItem
reload(QuickSelectRuleItem)


class QuickSelectCreateWindow(QtWidgets.QWidget):
    def __init__(self,p):
        super(QuickSelectCreateWindow, self).__init__(parent=p)
        # self.widget = QtWidgets.QWidget()
        self.ui = QuickSelectCreateWidget.Ui_Form()
        self.ui.setupUi(self)

        self.setWindowFlags(self.windowFlags() | Qt.Dialog)
        self.setWindowTitle("Quick Select Create")

        self.okCallBack = None
        self.itemList = {}
        self.ui.okBtn.clicked.connect(self.onOk)
        self.ui.ruleAddBtn.clicked.connect(self.onAdd)

    def GetCurrentDir(self):
        cc = os.path.abspath(os.path.dirname(__file__))
        return cc.replace('\\', '/')

    def setFinishCallBack(self,func):
        self.okCallBack = func

    def getSampleName(self,nodeName):
        ix = nodeName.rfind(':')
        name = nodeName
        if ix > -1:
            name = nodeName[ix+1:]
        return name

    def checkSame(self,data,name):
        for k in data['ModeData']:
            if k['name'] == name:
                return True
        return False

    def onOk(self):
        curPath = self.GetCurrentDir()
        ruleFile = curPath + '/rule.json'
        data = {}
        if os.path.exists(ruleFile):
            with open(ruleFile,'r') as inFile:
                data = json.load(inFile)
                inFile.close()
        else:
            data['CurrentMode'] = ''
            data['ModeData'] = []
        ruleName = self.ui.modeNameEdit.text()
        if ruleName == '':
            QtWidgets.QMessageBox.warning(self,'warning','需要设置名字',QtWidgets.QMessageBox.Ok)
            return
        if len(self.itemList) == 0:
            QtWidgets.QMessageBox.warning(self, 'warning', '需要至少选择一个对象', QtWidgets.QMessageBox.Ok)
            return
        if self.checkSame(data,ruleName):
            QtWidgets.QMessageBox.warning(self, 'warning', '名字重复，请重新设置', QtWidgets.QMessageBox.Ok)
            return
        item = {}
        item['name'] = ruleName
        item['list'] = []
        for t in self.itemList:
            ruleName = t.getRuleName()
            nodeNames = t.getNodeNames()
            if ruleName == '' or len(nodeNames) == '':
                continue
            item['list'].append({'button':ruleName,'rule':nodeNames})

        data['ModeData'].append(item)
        jsonStr = json.dumps(data, indent=2, sort_keys=True)
        with open(ruleFile,'w') as outFile:
            outFile.write(jsonStr)
            outFile.close()
        if self.okCallBack:
            self.okCallBack()
        self.close()

    def delItemCallBack(self,item):
        row = self.ui.modeListWidget.row(self.itemList[item])
        self.ui.modeListWidget.takeItem(row)
        # self.ui.modeListWidget.removeItemWidget(self.itemList[item])
        del self.itemList[item]

    def onAdd(self):
        itemWidget = QuickSelectRuleItem.QuickSelectRuleItem()
        itemWidget.setDelCallBack(self.delItemCallBack)
        item = QtWidgets.QListWidgetItem(self.ui.modeListWidget)
        item.setSizeHint(QtCore.QSize(0, 123));
        self.ui.modeListWidget.addItem(item)
        self.ui.modeListWidget.setItemWidget(item,itemWidget)
        self.itemList[itemWidget] = item
        # itemWidget.show()
        # print(itemWidget)




