# -*- coding: utf-8 -*-
#create by zhaotao
from PySide2 import QtWidgets, QtCore, QtGui
from PySide2.QtCore import Qt
import os
import json
import pymel.core as pm
import QuickSelectModifyWidget
reload(QuickSelectModifyWidget)
import QuickSelectRuleItem
reload(QuickSelectRuleItem)


class QuickSelectModifyWindow(QtWidgets.QWidget):
    def __init__(self,p):
        super(QuickSelectModifyWindow, self).__init__(parent=p)
        # self.widget = QtWidgets.QWidget()
        self.ui = QuickSelectModifyWidget.Ui_Form()
        self.ui.setupUi(self)

        self.setWindowFlags(self.windowFlags() | Qt.Dialog)
        self.setWindowTitle("Quick Select Modify")

        self.okCallBack = None
        self.delCallBack = None
        self.itemList = {}
        self.ui.okBtn.clicked.connect(self.onOk)
        self.ui.ruleAddBtn.clicked.connect(self.onAdd)
        self.ui.delBtn.clicked.connect(self.onDel)

    def setModifyData(self,data):
        self.Data = data
        self.refreshWidget()

    def GetCurrentDir(self):
        cc = os.path.abspath(os.path.dirname(__file__))
        return cc.replace('\\', '/')

    def setFinishCallBack(self,func):
        self.okCallBack = func

    def setDelCallBack(self,func):
        self.delCallBack = func

    def getSampleName(self,nodeName):
        ix = nodeName.rfind(':')
        name = nodeName
        if ix > -1:
            name = nodeName[ix+1:]
        return name

    def onOk(self):
        ruleName = self.ui.modeNameEdit.text()
        if ruleName == '':
            QtWidgets.QMessageBox.warning(self,'warning','需要设置名字',QtWidgets.QMessageBox.Ok)
            return
        if len(self.itemList) == 0:
            QtWidgets.QMessageBox.warning(self, 'warning', '需要至少选择一个对象', QtWidgets.QMessageBox.Ok)
            return

        self.Data['name'] = ruleName
        self.Data['list'] = []
        for t in self.itemList:
            ruleName = t.getRuleName()
            nodeNames = t.getNodeNames()
            if ruleName == '' or len(nodeNames) == '':
                continue
            self.Data['list'].append({'button':ruleName,'rule':nodeNames})

        if self.okCallBack:
            self.okCallBack(self.Data['name'])
        self.close()

    def delItemCallBack(self,item):
        row = self.ui.modeListWidget.row(self.itemList[item])
        self.ui.modeListWidget.takeItem(row)
        # self.ui.modeListWidget.removeItemWidget(self.itemList[item])
        del self.itemList[item]

    def onAdd(self):
        itemWidget = QuickSelectRuleItem.QuickSelectRuleItem()
        itemWidget.setDelCallBack(self.delItemCallBack)
        item = QtWidgets.QListWidgetItem(self.ui.modeListWidget)
        item.setSizeHint(QtCore.QSize(0, 123));
        self.ui.modeListWidget.addItem(item)
        self.ui.modeListWidget.setItemWidget(item,itemWidget)
        self.itemList[itemWidget] = item
        # itemWidget.show()
        # print(itemWidget)

    def onDel(self):
        if self.delCallBack:
            self.delCallBack(self.Data['name'])
        self.close()


    def refreshWidget(self):
        self.ui.modeNameEdit.setText(self.Data['name'])
        for k in self.Data['list']:
            itemWidget = QuickSelectRuleItem.QuickSelectRuleItem()
            itemWidget.setDelCallBack(self.delItemCallBack)
            item = QtWidgets.QListWidgetItem(self.ui.modeListWidget)
            item.setSizeHint(QtCore.QSize(0, 123));
            itemWidget.setRuleName(k['button'])
            itemWidget.setRuleNodes(k['rule'])
            self.ui.modeListWidget.addItem(item)
            self.ui.modeListWidget.setItemWidget(item, itemWidget)
            self.itemList[itemWidget] = item