# -*- coding: UTF-8 -*-
# created by zhaotao on 2020-5-14
# UI Control Class

from PySide2 import QtWidgets, QtCore, QtGui
from PySide2.QtCore import Qt
import pymel.core as pm

class QuickSelectRuleButton(QtWidgets.QPushButton):
    def __init__(self):
        super(QuickSelectRuleButton, self).__init__()
        self.rule = []
        self.clicked.connect(self.onClick)

    def setRule(self,name,rule):
        self.rule = rule
        self.setText(name)

    def checkMatch(self,nodeName):
        for k in self.rule:
            if nodeName.endswith(k):
                return True
        return False

    def onClick(self):
        nodes = pm.ls()
        for k in nodes:
            if self.checkMatch(k.name()):
                pm.select(k.name(),add=1)