# -*- coding: UTF-8 -*-
# created by zhaotao on 2020-5-14
# UI Control Class

from PySide2 import QtWidgets, QtCore, QtGui
from PySide2.QtCore import Qt
import pymel.core as pm

import QuickSelectRuleItemUI
reload(QuickSelectRuleItemUI)

class QuickSelectRuleItem(QtWidgets.QWidget):
    def __init__(self):
        super(QuickSelectRuleItem, self).__init__()
        # self.widget = QtWidgets.QWidget()
        self.ui = QuickSelectRuleItemUI.Ui_Form()
        self.ui.setupUi(self)
        self.resize(400, 123)
        self.delCallBack = None
        self.ui.ruleSelBtn.clicked.connect(self.onSel)
        self.ui.ruleDelBtn.clicked.connect(self.onDel)

    def setDelCallBack(self,func):
        self.delCallBack = func

    def setRuleName(self,name):
        self.ui.ruleNameEdit.setText(name)

    def setRuleNodes(self,nodes):
        st = '\n'
        nodeStr = st.join(nodes)
        self.ui.ruleNodesText.setText(nodeStr)

    def onSel(self):
        nodes = pm.selected()
        for n in nodes:
            name = n.name()
            ix = name.rfind(':')
            if ix > -1:
                name = name[ix+1:]
            self.ui.ruleNodesText.append(name)

    def onDel(self):
        if self.delCallBack != None:
            self.delCallBack(self)

    def getRuleName(self):
        return self.ui.ruleNameEdit.text()

    def getNodeNames(self):
        namesStr = self.ui.ruleNodesText.toPlainText()
        names = namesStr.strip('\n').split('\n')
        return names



